// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

package com.btcpiyush.ads.google_applovin_unity_ads;

import android.content.Context;

import androidx.annotation.NonNull;

import com.applovin.mediation.ads.MaxAdView;
import com.applovin.sdk.AppLovinSdk;
import com.facebook.ads.Ad;
import com.facebook.ads.AdSize;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.ads.admanager.AdManagerAdView;

/** Creates AdView and AdManagerAdViews for banner ads. */
public class BannerAdCreator {

  @NonNull private final Context context;

  BannerAdCreator(@NonNull Context context) {
    this.context = context;
  }

  /** Create a new {@link AdManagerAdView}. */
  AdManagerAdView createAdManagerAdView() {
    return new AdManagerAdView(context);
  }

  /** Create a new {@link AdView}. */
  AdView createAdView() {
    return new AdView(context);
  }

  /** Create a new {@link AdView}. */
  MaxAdView createAppLovinAdView(String bannerId, AppLovinSdk appLovinSDK) {
    return new MaxAdView(bannerId, appLovinSDK, context);
  }

  /** Create a new {@link AdView}. */
  com.facebook.ads.AdView createFacebookAdView(String bannerId, AdSize size) {
    return new com.facebook.ads.AdView(context, bannerId, size);
  }
}