// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

package com.btcpiyush.ads.google_applovin_unity_ads;

import androidx.annotation.NonNull;

import com.applovin.sdk.AppLovinSdkConfiguration;

import java.util.HashMap;
import java.util.Map;

/**
 * Wrapper around {@link AppLovinSdkConfiguration} for the
 * Flutter Google Mobile Ads Plugin.
 */
class FlutterAppLovinInitializationStatus {
  @NonNull final Map<String, String> adapterStatuses;

  FlutterAppLovinInitializationStatus(@NonNull Map<String, String> adapterStatuses) {
    this.adapterStatuses = adapterStatuses;
  }

  FlutterAppLovinInitializationStatus(@NonNull AppLovinSdkConfiguration initializationStatus) {
    final HashMap<String, String> newStatusMap = new HashMap<>();
    newStatusMap.put("country_code", initializationStatus.getCountryCode());
    newStatusMap.put("dialog_state", initializationStatus.getConsentDialogState().toString());

    this.adapterStatuses = newStatusMap;
  }
}
