// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.


package com.btcpiyush.ads.google_applovin_unity_ads;

import androidx.annotation.NonNull;

import com.google.android.gms.ads.initialization.AdapterStatus;
import com.google.android.gms.ads.initialization.InitializationStatus;

import java.util.HashMap;
import java.util.Map;

/**
 * Wrapper around {@link InitializationStatus} for the
 * Flutter Google Mobile Ads Plugin.
 */
class FlutterInitializationStatus {
  @NonNull final Map<String, FlutterAdapterStatus> adapterStatuses;

  FlutterInitializationStatus(@NonNull Map<String, FlutterAdapterStatus> adapterStatuses) {
    this.adapterStatuses = adapterStatuses;
  }

  FlutterInitializationStatus(@NonNull InitializationStatus initializationStatus) {
    final HashMap<String, FlutterAdapterStatus> newStatusMap = new HashMap<>();
    final Map<String, AdapterStatus> adapterStatusMap = initializationStatus.getAdapterStatusMap();

    for (Map.Entry<String, AdapterStatus> status : adapterStatusMap.entrySet()) {
      newStatusMap.put(status.getKey(), new FlutterAdapterStatus(status.getValue()));
    }

    this.adapterStatuses = newStatusMap;
  }
}
