// Copyright 2022 Bitcoding

package com.btcpiyush.ads.google_applovin_unity_ads;

import androidx.annotation.Nullable;

import com.btcpiyush.ads.google_applovin_unity_ads.FlutterVideoOptions;
import com.google.android.gms.ads.nativead.NativeAdOptions;

/**
 * A wrapper for {@link NativeAdOptions}.
 */
class FlutterNativeAdOptions {

    @Nullable
    final Integer adChoicesPlacement;
    @Nullable
    final Integer mediaAspectRatio;
    @Nullable
    final FlutterVideoOptions videoOptions;
    @Nullable
    final Boolean requestCustomMuteThisAd;
    @Nullable
    final Boolean shouldRequestMultipleImages;
    @Nullable
    final Boolean shouldReturnUrlsForImageAssets;

    FlutterNativeAdOptions(
            @Nullable Integer adChoicesPlacement,
            @Nullable Integer mediaAspectRatio,
            @Nullable FlutterVideoOptions videoOptions,
            @Nullable Boolean requestCustomMuteThisAd,
            @Nullable Boolean shouldRequestMultipleImages,
            @Nullable Boolean shouldReturnUrlsForImageAssets) {
        this.adChoicesPlacement = adChoicesPlacement;
        this.mediaAspectRatio = mediaAspectRatio;
        this.videoOptions = videoOptions;
        this.requestCustomMuteThisAd = requestCustomMuteThisAd;
        this.shouldRequestMultipleImages = shouldRequestMultipleImages;
        this.shouldReturnUrlsForImageAssets = shouldReturnUrlsForImageAssets;
    }

    NativeAdOptions asNativeAdOptions() {
        NativeAdOptions.Builder builder = new NativeAdOptions.Builder();
        if (adChoicesPlacement != null) {
            builder.setAdChoicesPlacement(adChoicesPlacement);
        }
        if (mediaAspectRatio != null) {
            builder.setMediaAspectRatio(mediaAspectRatio);
        }
        if (videoOptions != null) {
            builder.setVideoOptions(videoOptions.asVideoOptions());
        }
        if (requestCustomMuteThisAd != null) {
            builder.setRequestCustomMuteThisAd(requestCustomMuteThisAd);
        }
        if (shouldRequestMultipleImages != null) {
            builder.setRequestMultipleImages(shouldRequestMultipleImages);
        }
        if (shouldReturnUrlsForImageAssets != null) {
            builder.setReturnUrlsForImageAssets(shouldReturnUrlsForImageAssets);
        }
        return builder.build();
    }
}
