// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

package com.btcpiyush.ads.google_applovin_unity_ads;

import androidx.annotation.NonNull;

import com.google.android.gms.ads.AdValue;
import com.google.android.gms.ads.OnPaidEventListener;

/**
 * Implementation of {@link OnPaidEventListener} that sends events to {@link AdInstanceManager}.
 */
public class FlutterPaidEventListener implements OnPaidEventListener {
    @NonNull
    private final AdInstanceManager manager;
    @NonNull
    private final FlutterAd ad;

    FlutterPaidEventListener(@NonNull AdInstanceManager manager, @NonNull FlutterAd ad) {
        this.manager = manager;
        this.ad = ad;
    }

    @Override
    public void onPaidEvent(AdValue adValue) {
        FlutterAdValue value =
                new FlutterAdValue(
                        adValue.getPrecisionType(), adValue.getCurrencyCode(), adValue.getValueMicros());
        manager.onPaidEvent(ad, value);
    }
}
