// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

package com.btcpiyush.ads.google_applovin_unity_ads;

import androidx.annotation.Nullable;

import com.google.android.gms.ads.VideoOptions;

/** A wrapper for {@link VideoOptions}. */
class FlutterVideoOptions {
  @Nullable final Boolean clickToExpandRequested;
  @Nullable final Boolean customControlsRequested;
  @Nullable final Boolean startMuted;

  FlutterVideoOptions(
      @Nullable Boolean clickToExpandRequested,
      @Nullable Boolean customControlsRequested,
      @Nullable Boolean startMuted) {
    this.clickToExpandRequested = clickToExpandRequested;
    this.customControlsRequested = customControlsRequested;
    this.startMuted = startMuted;
  }

  VideoOptions asVideoOptions() {
    VideoOptions.Builder builder = new VideoOptions.Builder();
    if (clickToExpandRequested != null) {
      builder.setClickToExpandRequested(clickToExpandRequested);
    }
    if (customControlsRequested != null) {
      builder.setCustomControlsRequested(customControlsRequested);
    }
    if (startMuted != null) {
      builder.setStartMuted(startMuted);
    }
    return builder.build();
  }
}
