import 'dart:ffi';

class Settings {
  List<String>? adsSequence;
  List<String>? intraAdsSequence;
  List<String>? rewardsAdsSequence;
  List<String>? bannerAdsSequence;
  List<String>? nativeAdsSequence;
  List<String>? openAdsSequence;
  String? moreAppUrl;
  String? extraUrl;
  String? moreLiveApps;
  String? iptvPlayerUrl;
  bool? isAllAds;
  AdSetting? adSetting;
  AppUpdate? appUpdate;
  ExitDialog? exitDialog;
  RewardDialog? rewardDialog;
  AboutApp? aboutApp;
  RateApp? rateApp;
  ShareApp? shareApp;
  PrivacyPolicy? privacyPolicy;
  TermsOfUse? termsOfUse;
  ErrorReport? errorReport;
  FeedbackSupport? feedbackSupport;
  GoogleAds? googleAds;
  FacebookAds? facebookAds;
  CustomAds? customAds;
  AppLovin? appLovin;
  UnityAds? unityAds;

  Settings(
      {this.adsSequence,
      this.intraAdsSequence,
      this.rewardsAdsSequence,
      this.bannerAdsSequence,
      this.nativeAdsSequence,
      this.openAdsSequence,
      this.moreAppUrl,
      this.extraUrl,
      this.isAllAds,
      this.moreLiveApps,
      this.iptvPlayerUrl,
      this.adSetting,
      this.appUpdate,
      this.exitDialog,
      this.rewardDialog,
      this.aboutApp,
      this.rateApp,
      this.shareApp,
      this.privacyPolicy,
      this.termsOfUse,
      this.errorReport,
      this.feedbackSupport,
      this.googleAds,
      this.facebookAds,
      this.customAds,
      this.appLovin,
      this.unityAds});

  Settings.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('ads_sequence')) {
      adsSequence = json['ads_sequence'].cast<String>();
    }

    if (json.containsKey('intra_ads_sequence')) {
      intraAdsSequence = json['intra_ads_sequence'].cast<String>();
    } else {
      if (adsSequence != null) {
        intraAdsSequence = [];
        intraAdsSequence?.addAll(adsSequence!);
      }
    }

    if (json.containsKey('rewards_ads_sequence')) {
      rewardsAdsSequence = json['rewards_ads_sequence'].cast<String>();
    } else {
      if (adsSequence != null) {
        rewardsAdsSequence = [];
        rewardsAdsSequence?.addAll(adsSequence!);
      }
    }

    if (json.containsKey('native_ads_sequence')) {
      nativeAdsSequence = json['native_ads_sequence'].cast<String>();
    } else {
      if (adsSequence != null) {
        nativeAdsSequence = [];
        nativeAdsSequence?.addAll(adsSequence!);
      }
    }

    if (json.containsKey('banner_ads_sequence')) {
      bannerAdsSequence = json['banner_ads_sequence'].cast<String>();
    } else {
      if (adsSequence != null) {
        bannerAdsSequence = [];
        bannerAdsSequence?.addAll(adsSequence!);
      }
    }

    if (json.containsKey('open_ads_sequence')) {
      openAdsSequence = json['open_ads_sequence'].cast<String>();
    } else {
      if (adsSequence != null) {
        openAdsSequence = [];
        openAdsSequence?.addAll(adsSequence!);
      }
    }

    if (json.containsKey('more_app_url')) {
      moreAppUrl = json['more_app_url'];
    }

    if (json.containsKey('extra_url')) {
      extraUrl = json['extra_url'];
    }

    if (json.containsKey('more_live_apps')) {
      moreLiveApps = json['more_live_apps'];
    }

    if (json.containsKey('iptv_player_url')) {
      iptvPlayerUrl = json['iptv_player_url'];
    }

    if (json.containsKey('ad_setting')) {
      adSetting = json['ad_setting'] != null
          ? AdSetting.fromJson(json['ad_setting'])
          : null;
    }

    if (json.containsKey('app_update')) {
      appUpdate = json['app_update'] != null
          ? AppUpdate.fromJson(json['app_update'])
          : null;
    }

    if (json.containsKey('is_all_ads')) {
      isAllAds = json['is_all_ads'] ?? false;
    }

    if (json.containsKey('exit_dialog')) {
      exitDialog = json['exit_dialog'] != null
          ? ExitDialog.fromJson(json['exit_dialog'])
          : null;
    }

    if (json.containsKey('reward_dialog')) {
      rewardDialog = json['reward_dialog'] != null
          ? RewardDialog.fromJson(json['reward_dialog'])
          : null;
    }

    if (json.containsKey('About_App')) {
      aboutApp = json['About_App'] != null
          ? AboutApp.fromJson(json['About_App'])
          : null;
    }

    if (json.containsKey('rate_app')) {
      rateApp =
          json['rate_app'] != null ? RateApp.fromJson(json['rate_app']) : null;
    }

    if (json.containsKey('share_app')) {
      shareApp = json['share_app'] != null
          ? ShareApp.fromJson(json['share_app'])
          : null;
    }

    if (json.containsKey('privacy_policy')) {
      privacyPolicy = json['privacy_policy'] != null
          ? PrivacyPolicy.fromJson(json['privacy_policy'])
          : null;
    }

    if (json.containsKey('terms_of_use')) {
      termsOfUse = json['terms_of_use'] != null
          ? TermsOfUse.fromJson(json['terms_of_use'])
          : null;
    }

    if (json.containsKey('error_report')) {
      errorReport = json['error_report'] != null
          ? ErrorReport.fromJson(json['error_report'])
          : null;
    }

    if (json.containsKey('feedback_support')) {
      feedbackSupport = json['feedback_support'] != null
          ? FeedbackSupport.fromJson(json['feedback_support'])
          : null;
    }

    if (json.containsKey('google_ads')) {
      googleAds = json['google_ads'] != null
          ? GoogleAds.fromJson(json['google_ads'])
          : null;
    }

    if (json.containsKey('facebook_ads')) {
      facebookAds = json['facebook_ads'] != null
          ? FacebookAds.fromJson(json['facebook_ads'])
          : null;
    }

    if (json.containsKey('custom_ads')) {
      customAds = json['custom_ads'] != null
          ? CustomAds.fromJson(json['custom_ads'])
          : null;
    }

    if (json.containsKey('app_lovin')) {
      appLovin = json['app_lovin'] != null
          ? AppLovin.fromJson(json['app_lovin'])
          : null;
    }

    if (json.containsKey('unity_ads')) {
      unityAds = json['unity_ads'] != null
          ? UnityAds.fromJson(json['unity_ads'])
          : null;
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['ads_sequence'] = adsSequence;
    data['more_app_url'] = moreAppUrl;
    data['extra_url'] = extraUrl;
    data['more_live_apps'] = moreLiveApps;
    data['iptv_player_url'] = iptvPlayerUrl;
    if (adSetting != null) {
      data['ad_setting'] = adSetting?.toJson();
    }
    if (appUpdate != null) {
      data['app_update'] = appUpdate?.toJson();
    }
    if (exitDialog != null) {
      data['exit_dialog'] = exitDialog?.toJson();
    }
    if (rewardDialog != null) {
      data['reward_dialog'] = rewardDialog?.toJson();
    }
    if (aboutApp != null) {
      data['About_App'] = aboutApp?.toJson();
    }
    if (rateApp != null) {
      data['rate_app'] = rateApp?.toJson();
    }
    if (shareApp != null) {
      data['share_app'] = shareApp?.toJson();
    }
    if (privacyPolicy != null) {
      data['privacy_policy'] = privacyPolicy?.toJson();
    }
    if (termsOfUse != null) {
      data['terms_of_use'] = termsOfUse?.toJson();
    }
    if (errorReport != null) {
      data['error_report'] = errorReport?.toJson();
    }
    if (feedbackSupport != null) {
      data['feedback_support'] = feedbackSupport?.toJson();
    }
    if (isAllAds != null) {
      data['is_all_ads'] = isAllAds;
    }
    if (googleAds != null) {
      data['google_ads'] = googleAds?.toJson();
    }
    if (facebookAds != null) {
      data['facebook_ads'] = facebookAds?.toJson();
    }
    if (customAds != null) {
      data['custom_ads'] = customAds?.toJson();
    }
    if (appLovin != null) {
      data['app_lovin'] = appLovin?.toJson();
    }
    if (unityAds != null) {
      data['unity_ads'] = unityAds?.toJson();
    }
    return data;
  }
}

class AdSetting {
  int? appVersionCode;
  bool? isFullAds;
  String? onesignalId;
  String? adsLoadingText;
  bool? isGeoedgeSdkFlag = false;
  String? geoedgeSdkKey;
  int? interestialAdsInterval;
  int? interestialAdsTimingInterval;
  int? interestialAdsCustomImpressionInterval;
  int? interestialAdsCustomImpressionCount = 0;
  int interestialAdsIntervalCount = 1;
  int nativeAdsStep = -1;
  int bannerAdsStep = -1;
  int? geoedgeSdkKeyTimeoutInSeconds = 0;
  int? nativeAdListInterval = 0;
  int? secondsRequireTrigerReward = 0;

  AdSetting(
      {this.appVersionCode,
      this.isFullAds,
      this.onesignalId,
      this.adsLoadingText,
      this.interestialAdsInterval,
      this.interestialAdsCustomImpressionInterval,
      this.isGeoedgeSdkFlag,
      this.geoedgeSdkKey,
      this.nativeAdListInterval,
      this.secondsRequireTrigerReward,
      this.geoedgeSdkKeyTimeoutInSeconds,
      this.interestialAdsTimingInterval});

  AdSetting.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('app_version_code')) {
      appVersionCode = json['app_version_code'];
    }

    if (json.containsKey('is_full_ads')) {
      isFullAds = json['is_full_ads'];
    }

    if (json.containsKey('onesignal_id')) {
      onesignalId = json['onesignal_id'];
    }

    if (json.containsKey('ads_loading_text')) {
      adsLoadingText = json['ads_loading_text'];
    }

    if (json.containsKey('global_intra_interval_click')) {
      interestialAdsInterval = json['global_intra_interval_click'];
    }

    if (json.containsKey('global_intra_custom_impression')) {
      interestialAdsCustomImpressionInterval = json['global_intra_custom_impression'];
    }

    if (json.containsKey('interstitial_ad_time_interval')) {
      interestialAdsTimingInterval = json['interstitial_ad_time_interval'];
    }

    if (json.containsKey('native_ad_list_interval')) {
      nativeAdListInterval = json['native_ad_list_interval'];
    }

    if (json.containsKey('seconds_require_triger_reward')) {
      secondsRequireTrigerReward = json['seconds_require_triger_reward'];
    }

    if (json.containsKey('geoedge_sdk_key')) {
      geoedgeSdkKey = json['geoedge_sdk_key'];
    }

    if (json.containsKey('is_geoedge_sdk_flag')) {
      isGeoedgeSdkFlag = json['is_geoedge_sdk_flag'];
    }

    if (json.containsKey('geoedge_sdk_timeout_in_seconds')) {
      try {
        geoedgeSdkKeyTimeoutInSeconds = json['geoedge_sdk_timeout_in_seconds'];
      } catch (e) {
        geoedgeSdkKeyTimeoutInSeconds = 0;
      }
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['app_version_code'] = appVersionCode;
    data['is_full_ads'] = isFullAds;
    data['onesignal_id'] = onesignalId;
    data['ads_loading_text'] = adsLoadingText;
    data['global_intra_interval_click'] = interestialAdsInterval;
    data['interstitial_ad_time_interval'] = interestialAdsTimingInterval;
    data['global_intra_custom_impression'] = interestialAdsCustomImpressionInterval;
    data['native_ad_list_interval'] = nativeAdListInterval;
    data['seconds_require_triger_reward'] = secondsRequireTrigerReward;
    data['geoedge_sdk_key'] = geoedgeSdkKey;
    data['is_geoedge_sdk_flag'] = isGeoedgeSdkFlag;
    data['geoedge_sdk_timeout_in_seconds'] = geoedgeSdkKeyTimeoutInSeconds;
    return data;
  }
}

class AppUpdate {
  bool? isPopupDialog;
  bool? isUpdateRequire;
  String? packageId;
  String? websiteUrl;
  String? appIcon;
  int? updatedVersionCode;
  int? changeDialogdataClickCount;
  String? title;
  String? defaultMessage;
  String? appListUrl;
  bool? isShuffle;

  AppUpdate(
      {this.isPopupDialog,
      this.isUpdateRequire,
      this.packageId,
      this.websiteUrl,
      this.appIcon,
      this.updatedVersionCode,
      this.title,
      this.appListUrl,
      this.changeDialogdataClickCount,
      this.isShuffle,
      this.defaultMessage});

  AppUpdate.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_popup_dialog')) {
      isPopupDialog = json['is_popup_dialog'];
    }

    if (json.containsKey('is_update_require')) {
      isUpdateRequire = json['is_update_require'];
    }

    if (json.containsKey('package_id')) {
      packageId = json['package_id'];
    }

    if (json.containsKey('website_url')) {
      websiteUrl = json['website_url'];
    }

    if (json.containsKey('app_icon')) {
      appIcon = json['app_icon'];
    }

    if (json.containsKey('updated_version_code')) {
      updatedVersionCode = json['updated_version_code'];
    }

    if (json.containsKey('title')) {
      title = json['title'];
    }

    if (json.containsKey('default_message')) {
      defaultMessage = json['default_message'];
    }

    if (json.containsKey('is_shuffle')) {
      isShuffle = json['is_shuffle'];
    }

    if (json.containsKey('change_dialogdata_click_count')) {
      changeDialogdataClickCount = json['change_dialogdata_click_count'];
    }

    if (json.containsKey('app_list_url')) {
      appListUrl = json['app_list_url'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_popup_dialog'] = isPopupDialog;
    data['is_update_require'] = isUpdateRequire;
    data['package_id'] = packageId;
    data['website_url'] = websiteUrl;
    data['app_icon'] = appIcon;
    data['updated_version_code'] = updatedVersionCode;
    data['title'] = title;
    data['default_message'] = defaultMessage;
    data['is_shuffle'] = isShuffle;
    data['change_dialogdata_click_count'] = changeDialogdataClickCount;
    data['app_list_url'] = appListUrl;
    return data;
  }
}

class ExitDialog {
  bool? isExitRequire;
  String? exitTitle;
  String? exitMessage;

  ExitDialog({this.isExitRequire, this.exitTitle, this.exitMessage});

  ExitDialog.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_exit_require')) {
      isExitRequire = json['is_exit_require'];
    }

    if (json.containsKey('exit_title')) {
      exitTitle = json['exit_title'];
    }

    if (json.containsKey('exit_message')) {
      exitMessage = json['exit_message'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_exit_require'] = isExitRequire;
    data['exit_title'] = exitTitle;
    data['exit_message'] = exitMessage;
    return data;
  }
}

class RewardDialog {
  bool? isRewardRequire;
  String? rewardMessage;

  RewardDialog({this.isRewardRequire, this.rewardMessage});

  RewardDialog.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_reward_require')) {
      isRewardRequire = json['is_reward_require'];
    }

    if (json.containsKey('reward_message')) {
      rewardMessage = json['reward_message'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_reward_require'] = isRewardRequire;
    data['reward_message'] = rewardMessage;
    return data;
  }
}

class AboutApp {
  bool? isOverride;
  bool? isAboutApp;
  String? aboutTitle;
  String? aboutMessage;
  String? registrationDetail;
  String? versionDetail;

  AboutApp(
      {this.isOverride,
      this.isAboutApp,
      this.aboutTitle,
      this.aboutMessage,
      this.registrationDetail,
      this.versionDetail});

  AboutApp.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_override')) {
      isOverride = json['is_override'];
    }

    if (json.containsKey('is_about_app')) {
      isAboutApp = json['is_about_app'];
    }

    if (json.containsKey('about_title')) {
      aboutTitle = json['about_title'];
    }

    if (json.containsKey('about_message')) {
      aboutMessage = json['about_message'];
    }

    if (json.containsKey('registration_detail')) {
      registrationDetail = json['registration_detail'];
    }

    if (json.containsKey('version_detail')) {
      versionDetail = json['version_detail'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_override'] = isOverride;
    data['is_about_app'] = isAboutApp;
    data['about_title'] = aboutTitle;
    data['about_message'] = aboutMessage;
    data['registration_detail'] = registrationDetail;
    data['version_detail'] = versionDetail;
    return data;
  }
}

class RateApp {
  bool? isRateApp;
  String? packageId;
  String? rateAppUrl;
  String? rateMessage;

  RateApp({this.isRateApp, this.packageId, this.rateAppUrl, this.rateMessage});

  RateApp.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_rate_app')) {
      isRateApp = json['is_rate_app'];
    }

    if (json.containsKey('package_id')) {
      packageId = json['package_id'];
    }

    if (json.containsKey('rate_app_url')) {
      rateAppUrl = json['rate_app_url'];
    }

    if (json.containsKey('rate_message')) {
      rateMessage = json['rate_message'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_rate_app'] = isRateApp;
    data['package_id'] = packageId;
    data['rate_app_url'] = rateAppUrl;
    data['rate_message'] = rateMessage;
    return data;
  }
}

class ShareApp {
  bool? isShareApp;
  String? shareTitle;
  String? shareMessage;

  ShareApp({this.isShareApp, this.shareTitle, this.shareMessage});

  ShareApp.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_share_app')) {
      isShareApp = json['is_share_app'];
    }

    if (json.containsKey('share_title')) {
      shareTitle = json['share_title'];
    }

    if (json.containsKey('share_message')) {
      shareMessage = json['share_message'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_share_app'] = isShareApp;
    data['share_title'] = shareTitle;
    data['share_message'] = shareMessage;
    return data;
  }
}

class PrivacyPolicy {
  bool? isPrivacyPolicy;
  bool? isSystemBrowser;
  String? privacyPolicy;

  PrivacyPolicy(
      {this.isPrivacyPolicy, this.isSystemBrowser, this.privacyPolicy});

  PrivacyPolicy.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_privacy_policy')) {
      isPrivacyPolicy = json['is_privacy_policy'];
    }

    if (json.containsKey('is_system_browser')) {
      isSystemBrowser = json['is_system_browser'];
    }

    if (json.containsKey('privacy_policy')) {
      privacyPolicy = json['privacy_policy'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_privacy_policy'] = isPrivacyPolicy;
    data['is_system_browser'] = isSystemBrowser;
    data['privacy_policy'] = privacyPolicy;
    return data;
  }
}

class TermsOfUse {
  bool? isTermsOfUse;
  bool? isSystemBrowser;
  String? termsOfUse;

  TermsOfUse({this.isTermsOfUse, this.isSystemBrowser, this.termsOfUse});

  TermsOfUse.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_terms_of_use')) {
      isTermsOfUse = json['is_terms_of_use'];
    }

    if (json.containsKey('is_system_browser')) {
      isSystemBrowser = json['is_system_browser'];
    }

    if (json.containsKey('terms_of_use')) {
      termsOfUse = json['terms_of_use'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_terms_of_use'] = isTermsOfUse;
    data['is_system_browser'] = isSystemBrowser;
    data['terms_of_use'] = termsOfUse;
    return data;
  }
}

class ErrorReport {
  bool? isErrorReportSupport;
  String? emailId;

  ErrorReport({this.isErrorReportSupport, this.emailId});

  ErrorReport.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('terms_of_use')) {
      isErrorReportSupport = json['is_error_report_support'];
    }

    if (json.containsKey('email_id')) {
      emailId = json['email_id'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_error_report_support'] = isErrorReportSupport;
    data['email_id'] = emailId;
    return data;
  }
}

class FeedbackSupport {
  bool? isFeedbackSupport;
  String? emailId;
  String? feedbackTitle;
  String? feedbackMessage;
  String? emailSubject;
  String? emailMessage;

  FeedbackSupport(
      {this.isFeedbackSupport,
      this.emailId,
      this.feedbackTitle,
      this.feedbackMessage,
      this.emailSubject,
      this.emailMessage});

  FeedbackSupport.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('is_feedback_support')) {
      isFeedbackSupport = json['is_feedback_support'];
    }

    if (json.containsKey('email_id')) {
      emailId = json['email_id'];
    }

    if (json.containsKey('feedback_title')) {
      feedbackTitle = json['feedback_title'];
    }

    if (json.containsKey('feedback_message')) {
      feedbackMessage = json['feedback_message'];
    }

    if (json.containsKey('email_subject')) {
      emailSubject = json['email_subject'];
    }

    if (json.containsKey('email_message')) {
      emailMessage = json['email_message'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['is_feedback_support'] = isFeedbackSupport;
    data['email_id'] = emailId;
    data['feedback_title'] = feedbackTitle;
    data['feedback_message'] = feedbackMessage;
    data['email_subject'] = emailSubject;
    data['email_message'] = emailMessage;
    return data;
  }
}

class GoogleAds {
  String? bannerId;
  String? interestialId;
  String? appOpenAdId;
  String? nativeId;
  String? rewardedId;
  String? nativeVideoAdsId;
  bool? isBannerAds;
  bool? isRedirectCustomImpression;
  bool? isOpenAds;
  bool? isInterstitialAds;
  bool? isRewaredAds;
  bool? isNativeAds;
  int? interstitialInterval;

  GoogleAds(
      {this.bannerId,
      this.interestialId,
      this.appOpenAdId,
      this.nativeId,
      this.rewardedId,
      this.nativeVideoAdsId,
      this.isBannerAds,
      this.isRedirectCustomImpression,
      this.isOpenAds,
      this.isInterstitialAds,
      this.isRewaredAds,
      this.isNativeAds,
      this.interstitialInterval});

  GoogleAds.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('banner_ad_unit_id_android')) {
      bannerId = json['banner_ad_unit_id_android'];
    }

    if (json.containsKey('interstitial_ad_unit_id_android')) {
      interestialId = json['interstitial_ad_unit_id_android'];
    }
    // "is_redirect_custom_impression": false,
    if (json.containsKey('is_redirect_custom_impression')) {
      isRedirectCustomImpression = json['is_redirect_custom_impression'];
    }

    if (json.containsKey('app_open_ad_unit_id_android')) {
      appOpenAdId = json['app_open_ad_unit_id_android'];
    }

    if (json.containsKey('native_ads_unit_id_android')) {
      nativeId = json['native_ads_unit_id_android'];
    }

    if (json.containsKey('rewared_ads_unit_id')) {
      rewardedId = json['rewared_ads_unit_id'];
    }

    if (json.containsKey('native_video_ads_unit_id_android')) {
      nativeVideoAdsId = json['native_video_ads_unit_id_android'];
    }

    if (json.containsKey('is_banner_ads')) {
      isBannerAds = json['is_banner_ads'];
    }

    if (json.containsKey('is_open_ads')) {
      isOpenAds = json['is_open_ads'];
    }

    if (json.containsKey('is_interstitial_ads')) {
      isInterstitialAds = json['is_interstitial_ads'];
    }

    if (json.containsKey('is_rewared_ads')) {
      isRewaredAds = json['is_rewared_ads'];
    }

    if (json.containsKey('is_native_ads')) {
      isNativeAds = json['is_native_ads'];
    }

    if (json.containsKey('no_of_click_interstitial')) {
      interstitialInterval = json['no_of_click_interstitial'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['banner_ad_unit_id_android'] = bannerId;
    data['interstitial_ad_unit_id_android'] = interestialId;
    data['app_open_ad_unit_id_android'] = appOpenAdId;
    data['native_ads_unit_id_android'] = nativeId;
    data['rewared_ads_unit_id'] = rewardedId;
    data['native_video_ads_unit_id_android'] = nativeVideoAdsId;
    data['is_banner_ads'] = isBannerAds;
    data['is_open_ads'] = isOpenAds;
    data['is_redirect_custom_impression'] = isRedirectCustomImpression;
    data['is_interstitial_ads'] = isInterstitialAds;
    data['is_rewared_ads'] = isRewaredAds;
    data['is_native_ads'] = isNativeAds;
    data['no_of_click_interstitial'] = interstitialInterval;
    return data;
  }
}

class FacebookAds {
  String? bannerId;
  String? interestialId;
  String? rewardedId;
  String? nativeId;
  bool? isBannerAds;
  bool? isRedirectCustomImpression;
  bool? isInterstitialAds;
  bool? isRewaredAds;
  bool? isNativeAds;
  int? interstitialInterval;

  FacebookAds(
      {this.bannerId,
      this.interestialId,
      this.rewardedId,
      this.nativeId,
      this.isBannerAds,
      this.isRedirectCustomImpression,
      this.isInterstitialAds,
      this.isRewaredAds,
      this.isNativeAds,
      this.interstitialInterval});

  FacebookAds.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('banner_ad_unit_id_android')) {
      bannerId = json['banner_ad_unit_id_android'];
    }

    if (json.containsKey('interstitial_ad_unit_id_android')) {
      interestialId = json['interstitial_ad_unit_id_android'];
    }

    if (json.containsKey('rewared_ads_unit_id')) {
      rewardedId = json['rewared_ads_unit_id'];
    }

    if (json.containsKey('is_redirect_custom_impression')) {
      isRedirectCustomImpression = json['is_redirect_custom_impression'];
    }

    if (json.containsKey('native_ads_unit_id_android')) {
      nativeId = json['native_ads_unit_id_android'];
    }

    if (json.containsKey('is_banner_ads')) {
      isBannerAds = json['is_banner_ads'];
    }

    if (json.containsKey('is_interstitial_ads')) {
      isInterstitialAds = json['is_interstitial_ads'];
    }

    if (json.containsKey('is_rewared_ads')) {
      isRewaredAds = json['is_rewared_ads'];
    }

    if (json.containsKey('is_native_ads')) {
      isNativeAds = json['is_native_ads'];
    }

    if (json.containsKey('no_of_click_interstitial')) {
      interstitialInterval = json['no_of_click_interstitial'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['banner_ad_unit_id_android'] = bannerId;
    data['interstitial_ad_unit_id_android'] = interestialId;
    data['rewared_ads_unit_id'] = rewardedId;
    data['native_ads_unit_id_android'] = nativeId;
    data['is_banner_ads'] = isBannerAds;
    data['is_interstitial_ads'] = isInterstitialAds;
    data['is_redirect_custom_impression'] = isRedirectCustomImpression;
    data['is_rewared_ads'] = isRewaredAds;
    data['is_native_ads'] = isNativeAds;
    data['no_of_click_interstitial'] = interstitialInterval;
    return data;
  }
}

class CustomAds {
  String? qurekaLink;
  bool? isQurakaBanner;
  bool? isQurakaIntera;
  bool? isQurakaNative;
  bool? isRedirectCustomImpression;
  bool? closeButtonToDirectWeb;
  int? interstitialInterval;
  List<String>? qurakaIntraImage;
  List<String>? qurakaNativeImage;
  List<String>? qurakaBannerImage;

  CustomAds(
      {this.qurekaLink,
      this.isQurakaBanner,
      this.isQurakaIntera,
      this.isQurakaNative,
      this.interstitialInterval,
      this.closeButtonToDirectWeb,
      this.isRedirectCustomImpression,
      this.qurakaIntraImage,
      this.qurakaNativeImage,
      this.qurakaBannerImage});

  CustomAds.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('qureka_link')) {
      qurekaLink = json['qureka_link'];
    }

    if (json.containsKey('is_quraka_banner')) {
      isQurakaBanner = json['is_quraka_banner'];
    }

    if (json.containsKey('is_quraka_intera')) {
      isQurakaIntera = json['is_quraka_intera'];
    }

    if (json.containsKey('is_quraka_native')) {
      isQurakaNative = json['is_quraka_native'];
    }

    if (json.containsKey('is_redirect_custom_impression')) {
      isRedirectCustomImpression = json['is_redirect_custom_impression'];
    }

    if (json.containsKey('no_of_click_interstitial')) {
      interstitialInterval = json['no_of_click_interstitial'];
    }

    if (json.containsKey('close_button_to_direct_web')) {
      closeButtonToDirectWeb = json['close_button_to_direct_web'];
    }

    if (json.containsKey('quraka_intra_image')) {
      qurakaIntraImage = json['quraka_intra_image'].cast<String>();
    }

    if (json.containsKey('quraka_native_image')) {
      qurakaNativeImage = json['quraka_native_image'].cast<String>();
    }

    if (json.containsKey('quraka_banner_image')) {
      qurakaBannerImage = json['quraka_banner_image'].cast<String>();
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['qureka_link'] = qurekaLink;
    data['is_quraka_banner'] = isQurakaBanner;
    data['is_quraka_intera'] = isQurakaIntera;
    data['is_quraka_native'] = isQurakaNative;
    data['no_of_click_interstitial'] = interstitialInterval;
    data['is_redirect_custom_impression'] = isRedirectCustomImpression;
    data['close_button_to_direct_web'] = closeButtonToDirectWeb;
    data['quraka_intra_image'] = qurakaIntraImage;
    data['quraka_native_image'] = qurakaNativeImage;
    data['quraka_banner_image'] = qurakaBannerImage;
    return data;
  }
}

class AppLovin {
  String? sdkKey;
  bool? isUnlimitedAds;
  String? bannerId;
  String? interestialId;
  String? openId;
  AppLovinNative? nativeAds;
  String? rewaredId;
  bool? isRedirectCustomImpression;
  bool? isBannerAds;
  bool? isOpenAds;
  bool? isInterstitialAds;
  bool? isNativeAds;
  bool? isRewaredAds;

  AppLovin(
      {this.sdkKey,
      this.isUnlimitedAds,
      this.bannerId,
      this.interestialId,
      this.openId,
      this.nativeAds,
      this.rewaredId,
      this.isRedirectCustomImpression,
      this.isBannerAds,
      this.isOpenAds,
      this.isInterstitialAds,
      this.isNativeAds,
      this.isRewaredAds});

  AppLovin.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('sdk_key')) {
      sdkKey = json['sdk_key'];
    }

    if (json.containsKey('is_unlimited_ads')) {
      isUnlimitedAds = json['is_unlimited_ads'];
    }

    if (json.containsKey('id_unit_banner')) {
      bannerId = json['id_unit_banner'];
    }

    if (json.containsKey('id_unit_intra')) {
      interestialId = json['id_unit_intra'];
    }

    if (json.containsKey('id_unit_open')) {
      openId = json['id_unit_open'];
    }

    if (json.containsKey('id_unit_native_multiple')) {
      nativeAds = json['id_unit_native_multiple'] != null
          ? AppLovinNative.fromJson(json['id_unit_native_multiple'])
          : null;
    }

    if (json.containsKey('rewared_ads_unit_id')) {
      rewaredId = json['rewared_ads_unit_id'];
    }

    if (json.containsKey('is_banner_ads')) {
      isBannerAds = json['is_banner_ads'];
    }

    if (json.containsKey('is_redirect_custom_impression')) {
      isRedirectCustomImpression = json['is_redirect_custom_impression'];
    }

    if (json.containsKey('is_open_ads')) {
      isOpenAds = json['is_open_ads'];
    }

    if (json.containsKey('is_interstitial_ads')) {
      isInterstitialAds = json['is_interstitial_ads'];
    }

    if (json.containsKey('is_native_ads')) {
      isNativeAds = json['is_native_ads'];
    }

    if (json.containsKey('is_rewared_ads')) {
      isRewaredAds = json['is_rewared_ads'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['sdk_key'] = sdkKey;
    data['is_unlimited_ads'] = isUnlimitedAds;
    data['id_unit_banner'] = bannerId;
    data['id_unit_intra'] = interestialId;
    data['id_unit_open'] = openId;
    if (nativeAds != null) {
      data['id_unit_native_multiple'] = nativeAds?.toJson();
    }
    data['rewared_ads_unit_id'] = rewaredId;
    data['is_redirect_custom_impression'] = isRedirectCustomImpression;
    data['is_banner_ads'] = isBannerAds;
    data['is_open_ads'] = isOpenAds;
    data['is_interstitial_ads'] = isInterstitialAds;
    data['is_native_ads'] = isNativeAds;
    data['is_rewared_ads'] = isRewaredAds;
    return data;
  }
}

class AppLovinNative {
  String? small;
  String? medium;
  String? manual;

  AppLovinNative({this.small, this.medium, this.manual});

  AppLovinNative.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('small')) {
      small = json['small'];
    }

    if (json.containsKey('medium')) {
      medium = json['medium'];
    }

    if (json.containsKey('manual')) {
      manual = json['manual'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['small'] = small;
    data['medium'] = medium;
    data['manual'] = manual;
    return data;
  }
}

class UnityAds {
  String? gameId;
  bool? isIntraAds;
  bool? isBannerAds;
  bool? isRewaredAds;

  UnityAds({this.gameId, this.isIntraAds, this.isBannerAds, this.isRewaredAds});

  UnityAds.fromJson(Map<String, dynamic> json) {
    if (json.containsKey('game_id')) {
      gameId = json['game_id'];
    }

    if (json.containsKey('is_intra_ads')) {
      isIntraAds = json['is_intra_ads'];
    }

    if (json.containsKey('is_banner_ads')) {
      isBannerAds = json['is_banner_ads'];
    }

    if (json.containsKey('is_rewared_ads')) {
      isRewaredAds = json['is_rewared_ads'];
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = <String, dynamic>{};
    data['game_id'] = gameId;
    data['is_intra_ads'] = isIntraAds;
    data['is_banner_ads'] = isBannerAds;
    data['is_rewared_ads'] = isRewaredAds;
    return data;
  }
}
