// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

/// Callback for when the ad inspector closes.
typedef OnAdInspectorClosedListener = void Function(AdInspectorError?);

/// Error information about why the ad inspector failed.
class AdInspectorError {
  /// Create an AdInspectorError with the given code, domain and message.
  AdInspectorError({
    this.code,
    this.domain,
    this.message,
  });

  /// Code to identifier the error.
  final String? code;

  /// The domain from which the error came.
  final String? domain;

  /// A message detailing the error.
  final String? message;
}
