// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

import 'consent_form.dart';
import 'user_messaging_channel.dart';

/// Implementation for [ConsentForm],
class ConsentFormImpl extends ConsentForm {
  /// Construct a [ConsentFormImpl].
  ConsentFormImpl(this.platformHash);

  /// Identifier to the underlying platform object.
  final int platformHash;

  @override
  void show(OnConsentFormDismissedListener onConsentFormDismissedListener) {
    UserMessagingChannel.instance.show(this, onConsentFormDismissedListener);
  }

  @override
  Future<void> dispose() {
    return UserMessagingChannel.instance.disposeConsentForm(this);
  }

  @override
  bool operator ==(Object other) {
    return other is ConsentFormImpl && platformHash == other.platformHash;
  }
}
