// Copyright 2022 Bitcoding
// See the License for the specific language governing permissions and
// limitations under the License.

import 'consent_information.dart';
import 'consent_request_parameters.dart';
import 'user_messaging_channel.dart';

/// Implementation for ConsentInformation.
class ConsentInformationImpl extends ConsentInformation {
  /// Constructor for [ConsentInformationImpl].
  ConsentInformationImpl();

  @override
  void requestConsentInfoUpdate(
      ConsentRequestParameters params,
      OnConsentInfoUpdateSuccessListener successListener,
      OnConsentInfoUpdateFailureListener failureListener) {
    UserMessagingChannel.instance
        .requestConsentInfoUpdate(params, successListener, failureListener);
  }

  @override
  Future<bool> isConsentFormAvailable() {
    return UserMessagingChannel.instance.isConsentFormAvailable();
  }

  @override
  Future<ConsentStatus> getConsentStatus() {
    return UserMessagingChannel.instance.getConsentStatus();
  }

  @override
  Future<void> reset() {
    return UserMessagingChannel.instance.reset();
  }
}
